'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Stores asset in memory. Other implementations may store in file system, etc.
 *
 * @SERVER
 */
var AssetServer = function () {

  /**
   * @param {string} domain
   */

  /**
   * @type {{[key: string]: any}}
   */
  function AssetServer(domain) {
    _classCallCheck(this, AssetServer);

    this.assets = {};
    this.domain = domain;
  }

  /**
   * @param {string} path
   * @param {boolean} isSecure
   * @returns {string}
   */


  /**
   * @type {string}
   */


  _createClass(AssetServer, [{
    key: 'toUrl',
    value: function toUrl(path, isSecure) {
      var result = !!isSecure ? 'https://' : 'http://';
      result += this.toUrlWithoutProtocol(path);
      return result;
    }

    /**
     * @param {string} path
     * @returns {string}
     */

  }, {
    key: 'toUrlWithoutProtocol',
    value: function toUrlWithoutProtocol(path) {
      return _path2.default.join(this.domain, path);
    }

    /**
     * @param {string} path
     * @param {string} protocol
     * @returns {string}
     */

  }, {
    key: 'toUrlWithProtocol',
    value: function toUrlWithProtocol(path, protocol) {
      return protocol + '://' + this.toUrlWithoutProtocol(path);
    }

    /**
     * @param {string} path
     * @param {any} contents
     */

  }, {
    key: 'put',
    value: function put(path, contents) {
      this.assets[path] = contents;
    }

    /**
     * @param {ServerHttpRequest} httpRequest
     * @param {httpServerResponse} response
     * @returns {boolean}
     */

  }, {
    key: 'handle',
    value: function handle(httpRequest, response) {
      var parsedUrl = _url2.default.parse(httpRequest.url);
      var content = this.get(parsedUrl.pathname);
      if (content == null) {
        // Not an asset request.
        return false;
      }
      // TODO: Handle content type headers, content size, e-tag, etc.
      response.writeHead(200, { 'Content-Type': 'text/plain' });
      response.end(content);
    }

    /**
     * @param {string} path
     * @returns {{size: number; content: any}}
     */

  }, {
    key: 'get',
    value: function get(path) {
      return {
        size: this.assets[path].length,
        content: this.assets[path]
      };
    }
  }]);

  return AssetServer;
}();

exports.default = AssetServer;
//# sourceMappingURL=AssetServer.js.map