'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _AssetServer2 = require('../AssetServer');

var _AssetServer3 = _interopRequireDefault(_AssetServer2);

var _ServerHttpRequest = require('../../http/ServerHttpRequest.js');

var _ServerHttpRequest2 = _interopRequireDefault(_ServerHttpRequest);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mime = require('mime');

var _mime2 = _interopRequireDefault(_mime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Reads asset from the webpack output directory.
 *
 * TODO: Implement memory caching.
 *
 * @SERVER
 */
var WebpackAssetServer = function (_AssetServer) {
  _inherits(WebpackAssetServer, _AssetServer);

  /**
   * @param {string} assetHostPath
   * @param {string} absoluteTempDir
   * @param {Logger} logger
   */


  /**
   * @type {string}
   */
  function WebpackAssetServer(assetHostPath, absoluteTempDir, logger) {
    _classCallCheck(this, WebpackAssetServer);

    var _this = _possibleConstructorReturn(this, (WebpackAssetServer.__proto__ || Object.getPrototypeOf(WebpackAssetServer)).call(this, assetHostPath));

    _this._assetHostPath = assetHostPath;
    _this._absoluteTempDir = absoluteTempDir;
    _this._logger = logger;
    return _this;
  }

  /**
   * @param {string} assetPath
   * @returns {{size: number; content: any}}
   */


  /**
   * @type {Logger}
   */

  /**
   * @type {string}
   */


  _createClass(WebpackAssetServer, [{
    key: 'get',
    value: function get(assetPath) {
      var fullPath = _path2.default.join(this._absoluteTempDir, assetPath),
          stat;
      try {
        // TODO: We might have to switch to async for better performance here.
        stat = _fs2.default.statSync(fullPath);
        return {
          size: stat.size,
          content: _fs2.default.readFileSync(fullPath)
        };
      } catch (err) {
        this._logger.notice('Asset server failed to retrieve: \'' + fullPath + '\'.', err);
        return null;
      }
    }

    /**
     * @param {http.incomingMessage} request
     * @param {httpServerResponse} response
     * @returns {boolean}
     */

  }, {
    key: 'handle',
    value: function handle(request, response) {
      var httpRequest = new _ServerHttpRequest2.default(request);
      if (httpRequest.startsWith(this._assetHostPath)) {
        var fullRequestPath = _path2.default.join(httpRequest.getHost(), decodeURI(httpRequest.getPath()));
        var realPath = fullRequestPath.substr(this._assetHostPath.length);
        var asset = this.get(realPath);
        if (asset == null || asset.content == null) {
          return false;
        }
        // TODO: Handle e-tag, etc.
        response.writeHead(200, {
          'Content-Type': _mime2.default.lookup(realPath),
          'Content-Length': asset.size
        });
        response.end(asset.content);
        return true;
      }
      return false;
    }
  }]);

  return WebpackAssetServer;
}(_AssetServer3.default);

exports.default = WebpackAssetServer;
//# sourceMappingURL=WebpackAssetServer.js.map