'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ReduxStore2 = require('./ReduxStore.js');

var _ReduxStore3 = _interopRequireDefault(_ReduxStore2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * ReduxStore implementation that allows mocking of Services.
 *
 * @CLIENT_SERVER
 */
var MockableReduxStore = function (_ReduxStore) {
  _inherits(MockableReduxStore, _ReduxStore);

  function MockableReduxStore(initialState, clientConfig, cookieJar) {
    _classCallCheck(this, MockableReduxStore);

    var _this = _possibleConstructorReturn(this, (MockableReduxStore.__proto__ || Object.getPrototypeOf(MockableReduxStore)).call(this, initialState, clientConfig, cookieJar));

    _this._mockServices = {};
    return _this;
  }
  /**
   * @type {{[key: string]: Service}}
   */


  _createClass(MockableReduxStore, [{
    key: 'registerMockService',
    value: function registerMockService(ServiceClass) {
      var serviceId = ServiceClass.id();
      if (typeof serviceId != 'string') {
        throw new Error('Mock Service must implement Service: ' + ServiceClass);
      }
      this._mockServices[serviceId] = new ServiceClass(this._clientConfig, this._cookieJar);
    }
  }, {
    key: 'clearMocks',
    value: function clearMocks() {
      this._mockServices = {};
    }
  }, {
    key: 'getServiceDependencies',
    value: function getServiceDependencies(segmentId) {
      // This will make MockableReduxStore operate a little bit slower, but since
      // this implementation is only used in component browser/testing, it should
      // be okay.
      var serviceId,
          result = {};
      var services = this._serviceDependencies[segmentId];
      for (serviceId in services) {
        if (!services.hasOwnProperty(serviceId)) continue;
        if (this._mockServices.hasOwnProperty(serviceId)) {
          result[serviceId] = this._mockServices[serviceId];
        } else {
          result[serviceId] = services[serviceId];
        }
      }
      return result;
    }
  }]);

  return MockableReduxStore;
}(_ReduxStore3.default);

exports.default = MockableReduxStore;
//# sourceMappingURL=MockableReduxStore.js.map