'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Utility for generating dynamic action names.
 *
 * @CLIENT_SERVER
 */
exports.default = {
  /**
   * @param {string} name
   * @param {?string} prefix
   * @param {?string} suffix
   */
  generate: function generate(name, prefix, suffix) {
    var result = prefix && prefix != '' ? this.prep(prefix) + '_' : '';
    result += this.prep(name);
    result += suffix && suffix != '' ? '_' + this.prep(suffix) : '';
    return result;
  },


  /**
   * @param {string} text
   * @returns {string}
   */
  prep: function prep(text) {
    text = text.replace(/ /g, '_');
    return text.toUpperCase();
  }
};
//# sourceMappingURL=ActionNameUtil.js.map