'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Segment2 = require('../../Segment.js');

var _Segment3 = _interopRequireDefault(_Segment2);

var _ActionNameUtil = require('../ActionNameUtil.js');

var _ActionNameUtil2 = _interopRequireDefault(_ActionNameUtil);

var _QueryResult = require('../../QueryResult.js');

var _QueryResult2 = _interopRequireDefault(_QueryResult);

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * You can query LocalSegment by specifying keys separated by dots. Examples:
 * "key", "key.subKey", etc.
 *
 * @CLIENT_SERVER
 */
var LocalSegment = function (_Segment) {
  _inherits(LocalSegment, _Segment);

  function LocalSegment() {
    _classCallCheck(this, LocalSegment);

    return _possibleConstructorReturn(this, (LocalSegment.__proto__ || Object.getPrototypeOf(LocalSegment)).apply(this, arguments));
  }

  _createClass(LocalSegment, null, [{
    key: '__initialize',

    // We'll cache something at the Segment class. This isn't state, since it's
    // constant for all user Segment classes extending this class and won't
    // ever change.
    value: function __initialize() {
      var segment = this;
      if (segment.__INITIALIZED) return;
      var id = segment.id();
      var UPDATE_ACTION_TYPE = _ActionNameUtil2.default.generate(id, 'UPDATE');
      var CLEAN_ACTION_TYPE = _ActionNameUtil2.default.generate(id, 'CLEAN');
      segment.__ACTION_CREATOR = {
        createUpdateAction: function createUpdateAction(commands) {
          return {
            type: UPDATE_ACTION_TYPE,
            commands: commands
          };
        }
      };
      segment.__REDUCER = function (state, action) {
        if (state == null) state = segment.createInitialData();
        switch (action.type) {
          case CLEAN_ACTION_TYPE:
            // Since there are no concept of loading in local segment, init and
            // clean does the same thing, which is populating the segment with
            // initial data.
            return segment.createInitialData();
            break;
          case UPDATE_ACTION_TYPE:
            // Update using react immutability helper.
            return (0, _reactAddonsUpdate2.default)(state, action.commands);
            break;
        }
        return state;
      };
      segment.__INITIALIZED = true;
    }
  }, {
    key: 'getActionCreator',
    value: function getActionCreator() {
      this.__initialize();
      return this.__ACTION_CREATOR;
    }
  }, {
    key: 'getReducer',
    value: function getReducer() {
      this.__initialize();
      return this.__REDUCER;
    }
  }, {
    key: 'shouldHydrate',
    value: function shouldHydrate() {
      // Since this is local segment, it shouldn't be hydrated at server.
      return false;
    }

    /**
     * This is meant to be overridden by client.
     *
     * @returns {any}
     */

  }, {
    key: 'createInitialData',
    value: function createInitialData() {
      return {};
    }
  }, {
    key: 'generateQueryId',
    value: function generateQueryId(query) {
      if (typeof query != 'string') {
        throw new Error('Local segment query must be string. Found: \'' + query + '\'.');
      }
      return query;
    }
  }, {
    key: 'queryState',
    value: function queryState(query, queryId, segmentState) {
      if (segmentState == null) return _QueryResult2.default.loaded(null);
      if ((typeof segmentState === 'undefined' ? 'undefined' : _typeof(segmentState)) == 'object' && typeof queryId == 'string' && queryId != '') {
        var i,
            segment = segmentState,
            splitQuery = queryId.split('.');
        for (i = 0; i < splitQuery.length; i++) {
          if (segment.hasOwnProperty(splitQuery[i])) {
            segment = segment[splitQuery[i]];
          } else {
            return _QueryResult2.default.loaded(null);
          }
        }
        return _QueryResult2.default.loaded(segment);
      }
      return _QueryResult2.default.loaded(segmentState);
    }
  }]);

  return LocalSegment;
}(_Segment3.default);

exports.default = LocalSegment;
//# sourceMappingURL=LocalSegment.js.map