'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Segment2 = require('../../Segment.js');

var _Segment3 = _interopRequireDefault(_Segment2);

var _ActionNameUtil = require('../ActionNameUtil.js');

var _ActionNameUtil2 = _interopRequireDefault(_ActionNameUtil);

var _QueryResult = require('../../QueryResult.js');

var _QueryResult2 = _interopRequireDefault(_QueryResult);

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Organizes pieces inside its segment as simple key-value map. This means
 * segment piece granularity is limited to top-level values (you cannot
 * query a particular field, for instance).
 *
 * @CLIENT_SERVER
 */
var MapSegment = function (_Segment) {
  _inherits(MapSegment, _Segment);

  function MapSegment() {
    _classCallCheck(this, MapSegment);

    return _possibleConstructorReturn(this, (MapSegment.__proto__ || Object.getPrototypeOf(MapSegment)).apply(this, arguments));
  }

  _createClass(MapSegment, null, [{
    key: '__initialize',

    // We'll cache something at the Segment class. This isn't state, since it's
    // constant for all user Segment classes extending this class and won't
    // ever change.
    value: function __initialize() {
      var segment = this;
      if (segment.__INITIALIZED) return;
      var id = segment.id();
      var SET_ACTION_TYPE = _ActionNameUtil2.default.generate(id, 'SET');
      segment.__ACTION_CREATOR = {
        'set': function set(queryId, payload, errors) {
          return {
            type: SET_ACTION_TYPE,
            queryId: queryId,
            payload: {
              data: payload,
              updated: Date.now ? Date.now() : new Date().getTime(),
              errors: errors
            }
          };
        }
      };
      segment.__REDUCER = function (state, action) {
        // If state is undefined, return initial state.
        if (state == null) state = {};
        switch (action.type) {
          case SET_ACTION_TYPE:
            // Replace the map entry with the new loaded one.
            state = (0, _reactAddonsUpdate2.default)(state, _defineProperty({}, action.queryId, { $set: action.payload }));
            break;
        }
        return state;
      };
      segment.__INITIALIZED = true;
    }

    /**
     * If you find that you need to override this method, you're better off
     * creating your own Segment class, since overriding this method also means
     * overriding getReducer() and other methods in this class.
     *
     * @return {Object}
     */

  }, {
    key: 'getActionCreator',
    value: function getActionCreator() {
      this.__initialize();
      return this.__ACTION_CREATOR;
    }

    /**
     * @return {Function}
     */

  }, {
    key: 'getReducer',
    value: function getReducer() {
      this.__initialize();
      return this.__REDUCER;
    }
  }, {
    key: 'queryState',
    value: function queryState(query, queryId, segmentState) {
      if (segmentState == null) return _QueryResult2.default.notLoaded();
      var piece = segmentState[queryId];
      if (piece == null) return _QueryResult2.default.notLoaded();
      return _QueryResult2.default.loaded(piece);
    }
  }]);

  return MapSegment;
}(_Segment3.default);

exports.default = MapSegment;
//# sourceMappingURL=MapSegment.js.map