'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _CookieJar2 = require('./CookieJar.js');

var _CookieJar3 = _interopRequireDefault(_CookieJar2);

var _Cookie = require('./Cookie.js');

var _Cookie2 = _interopRequireDefault(_Cookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @CLIENT
 */
var ClientCookieJar = function (_CookieJar) {
  _inherits(ClientCookieJar, _CookieJar);

  function ClientCookieJar() {
    _classCallCheck(this, ClientCookieJar);

    return _possibleConstructorReturn(this, (ClientCookieJar.__proto__ || Object.getPrototypeOf(ClientCookieJar)).apply(this, arguments));
  }

  _createClass(ClientCookieJar, [{
    key: 'read',

    /**
     * @param {string} name
     * @return {?string}
     */
    value: function read(name) {
      var nameEQ = name + "=";
      var ca = document.cookie.split(';');
      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
          c = c.substring(1, c.length);
        }if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
      }
      return null;
    }

    /**
     * @param {Cookie} cookie
     */

  }, {
    key: 'set',
    value: function set(cookie) {
      var cookieStr = cookie.toDocumentString();
      document.cookie = cookieStr;
    }

    /**
     * @param {string} name
     * @param {string} domain
     * @param {boolean} secure
     * @param {?string} path
     */

  }, {
    key: 'remove',
    value: function remove(name, domain, secure, path) {
      var removalCookie = _Cookie2.default.createRemoval(name, domain, secure, path);
      this.set(removalCookie);
    }
  }]);

  return ClientCookieJar;
}(_CookieJar3.default);

exports.default = ClientCookieJar;
//# sourceMappingURL=ClientCookieJar.js.map