'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _parseQueryString = require('./parseQueryString.js');

var _parseQueryString2 = _interopRequireDefault(_parseQueryString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * TODO: A better abstraction for HttpRequest.
 *
 * @CLIENT
 */
var ClientHttpRequest = function () {
  /**
   * @type {Element}
   */
  function ClientHttpRequest() {
    _classCallCheck(this, ClientHttpRequest);

    this._element = document.createElement('A');
    this._element.href = window.location.href;
  }

  /**
   * @param {string} givenHostPath
   * @returns {boolean}
   */


  /**
   * @type {?Object}
   */


  _createClass(ClientHttpRequest, [{
    key: 'startsWith',
    value: function startsWith(givenHostPath) {
      var hostPath = this._element.host + this._element.pathname;
      return givenHostPath.substr(0, hostPath.length) == hostPath;
    }
  }, {
    key: 'getInnerRequest',
    value: function getInnerRequest() {
      return null;
    }
  }, {
    key: 'getMethod',
    value: function getMethod() {
      return null;
    }

    /**
     * @returns {boolean}
     */

  }, {
    key: 'isSecure',
    value: function isSecure() {
      return this._element.protocol == 'https:';
    }
  }, {
    key: 'getHeaders',
    value: function getHeaders() {
      // Page class should not read headers.
      // TODO: Implement a filter system that can add request-and-domain-based arguments reusable in both server and client side. Example usage: authentication filter.
      throw new Error('HttpRequest: getHeaders called in client context.');
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'getDomain',
    value: function getDomain() {
      // TODO: Implement.
      return '';
    }

    /**
     * @returns {number}
     */

  }, {
    key: 'getPort',
    value: function getPort() {
      // TODO: Implement.
      return 80;
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'getHost',
    value: function getHost() {
      return this._element.host;
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'getPath',
    value: function getPath() {
      return this._element.pathname;
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'getUrl',
    value: function getUrl() {
      return this._element.href;
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'getQuery',
    value: function getQuery() {
      return this._element.search;
    }

    /**
     * @returns {Object}
     */

  }, {
    key: 'getQueryParams',
    value: function getQueryParams() {
      // Parse query string.
      if (this._parsedQs == null) {
        this._parsedQs = (0, _parseQueryString2.default)(this.getQuery());
      }
      return this._parsedQs;
    }

    /**
     * @return {string}
     */

  }, {
    key: 'getHash',
    value: function getHash() {
      var hashString = this._element.hash;
      if (hashString.length > 0 && hashString[0] === '#') {
        return hashString.slice(1, hashString.length);
      }
      return hashString;
    }
  }, {
    key: 'getBody',
    value: function getBody() {
      return null;
    }
  }]);

  return ClientHttpRequest;
}();

exports.default = ClientHttpRequest;
//# sourceMappingURL=ClientHttpRequest.js.map