'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _ContentRenderer2 = require('../ContentRenderer');

var _ContentRenderer3 = _interopRequireDefault(_ContentRenderer2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * TODO: Upgrade to react 0.14.0!
 *
 * @SERVER
 */
var ReactRenderer = function (_ContentRenderer) {
  _inherits(ReactRenderer, _ContentRenderer);

  /**
   * @param {?string} head
   * @param {?ReactElement} body
   */

  /**
   * @type {string}
   */
  function ReactRenderer(head, body) {
    _classCallCheck(this, ReactRenderer);

    var _this = _possibleConstructorReturn(this, (ReactRenderer.__proto__ || Object.getPrototypeOf(ReactRenderer)).call(this));

    _this.head = head;
    _this.body = body;
    return _this;
  }

  /**
   * TODO: Send http request headers, request method, etc - if a config knob is turned on!
   * TODO: Find out a library for escaping URLs to be put in HTML.
   * TODO: Also print reverse routing data.
   *
   * @param {Object} routeArgs
   * @param {Object} routes
   * @param {Object} clientConfig
   * @param {any} hydratedState
   * @param {Object} pageDependencies
   * @returns {string}
   */


  /**
   * @type {ReactElement}
   */


  _createClass(ReactRenderer, [{
    key: 'render',
    value: function render(routeArgs, routes, clientConfig, hydratedState, pageDependencies) {
      var result = '<html>';
      result += '<head>';
      if (this.head) result += this.head;

      result += '<script type="text/javascript">';
      result += 'var config = ' + JSON.stringify(clientConfig) + ';';
      result += 'var routeArgs = ' + JSON.stringify(routeArgs) + ';';
      result += 'var routes = ' + JSON.stringify(routes) + ';';
      result += 'var hydratedState = ' + JSON.stringify(hydratedState) + ';';
      result += '</script>';

      var i, url;
      for (i = 0; i < pageDependencies.cssDependencies.length; i++) {
        url = pageDependencies.cssDependencies[i];
        result += '<link rel="stylesheet" type="text/css" href="' + url + '">';
      }

      result += '</head>';
      result += '<body><div id="__body">';
      if (this.body) result += _server2.default.renderToString(this.body);
      result += '</div>';

      for (i = 0; i < pageDependencies.jsDependencies.length; i++) {
        url = pageDependencies.jsDependencies[i];
        result += '<script type="text/javascript" src="' + url + '"></script>';
      }

      result += '</body>';
      result += '</html>';
      return result;
    }
  }]);

  return ReactRenderer;
}(_ContentRenderer3.default);

exports.default = ReactRenderer;
//# sourceMappingURL=ReactRenderer.js.map