"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateServerFile;
/**
 * @param {Object} pages
 * @param {Object} components
 */
function generateServerFile(pages, components) {
  var result = "import server from 'soya/lib/server';\nimport config from '../../config.js';\n\nvar pages = {}";

  var i;
  for (i = 0; i < pages.length; i++) {
    result += "\nimport Page" + i + " from '../../" + pages[i] + "';\npages['" + pages[i] + "'] = Page" + i + ";";
  }

  result += "\n\nvar components = " + JSON.stringify(components) + ";\n\n// Run server.\nserver(config, pages, components);";

  return result;
};
//# sourceMappingURL=generateServerFile.js.map