'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('./Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Node that checks that the path doesn't have segments.
 *
 * @CLIENT-SERVER
 */
var EmptyPathNode = function (_Node) {
  _inherits(EmptyPathNode, _Node);

  function EmptyPathNode() {
    _classCallCheck(this, EmptyPathNode);

    return _possibleConstructorReturn(this, (EmptyPathNode.__proto__ || Object.getPrototypeOf(EmptyPathNode)).apply(this, arguments));
  }

  _createClass(EmptyPathNode, [{
    key: 'evaluate',

    /**
     * @param {RoutingData} routingData
     * @returns {boolean}
     */
    value: function evaluate(routingData) {
      return routingData.isEmptyPath();
    }

    /**
     * @param {ReverseRoutingData} reverseRoutingData
     */

  }, {
    key: 'reverseEvaluate',
    value: function reverseEvaluate(reverseRoutingData) {
      reverseRoutingData.pathSegments = [];
    }

    /**
     * @returns {boolean}
     */

  }, {
    key: 'isConsumingSegmentOnMatch',
    value: function isConsumingSegmentOnMatch() {
      return false;
    }

    /**
     * @param {Node} node
     * @returns {boolean}
     */

  }, {
    key: 'equals',
    value: function equals(node) {
      return node instanceof EmptyPathNode;
    }
  }]);

  return EmptyPathNode;
}(_Node3.default);

exports.default = EmptyPathNode;
//# sourceMappingURL=EmptyPathNode.js.map