'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('./Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @CLIENT-SERVER
 */
var FinalPathNode = function (_Node) {
  _inherits(FinalPathNode, _Node);

  /**
   * @param {string} routeId
   * @param {string} pageName
   */

  /**
   * @type {string}
   */
  function FinalPathNode(routeId, pageName) {
    _classCallCheck(this, FinalPathNode);

    var _this = _possibleConstructorReturn(this, (FinalPathNode.__proto__ || Object.getPrototypeOf(FinalPathNode)).call(this));

    _this._routeId = routeId;
    _this._pageName = pageName;
    return _this;
  }

  /**
   * @param {RoutingData} routingData
   * @returns {boolean}
   */


  /**
   * @type {string}
   */


  _createClass(FinalPathNode, [{
    key: 'evaluate',
    value: function evaluate(routingData) {
      if (!routingData.isAllSegmentConsumed()) {
        // We only set routing result if all path is already consumed. Otherwise
        // this node does not match.
        return false;
      }
      routingData.resultPageName = this._pageName;
      routingData.resultRouteId = this._routeId;
      return true;
    }

    /**
     * @param {ReverseRoutingData} reverseRoutingData
     */

  }, {
    key: 'reverseEvaluate',
    value: function reverseEvaluate(reverseRoutingData) {
      reverseRoutingData.routeId = this._routeId;
      reverseRoutingData.pageName = this._pageName;
    }

    /**
     * @returns {boolean}
     */

  }, {
    key: 'isConsumingSegmentOnMatch',
    value: function isConsumingSegmentOnMatch() {
      return false;
    }

    /**
     * @param {Node} node
     * @returns {boolean}
     */

  }, {
    key: 'equals',
    value: function equals(node) {
      return node instanceof FinalPathNode && node._routeId == this._routeId && node._pageName == this._pageName;
    }
  }]);

  return FinalPathNode;
}(_Node3.default);

exports.default = FinalPathNode;
//# sourceMappingURL=FinalPathNode.js.map