'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('./Node');

var _Node3 = _interopRequireDefault(_Node2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @CLIENT-SERVER
 */
var MethodNode = function (_Node) {
  _inherits(MethodNode, _Node);

  _createClass(MethodNode, null, [{
    key: 'constructFromConfig',


    /**
     * @param {Array<any>} argArray
     * @returns {Array<Node>}
     */
    value: function constructFromConfig(argArray) {
      if (argArray.length != 1) {
        throw new Error('Domain node only receives one argument! Got ' + argArray.length + '.');
      }
      return [new MethodNode(argArray[0] + '')];
    }

    /**
     * @type {string}
     */

  }, {
    key: 'order',

    /**
     * @returns {number}
     */
    get: function get() {
      return 20;
    }

    /**
     * @returns {string}
     */

  }, {
    key: 'nodeName',
    get: function get() {
      return 'method';
    }
  }]);

  /**
   * @param {string} method
   */
  function MethodNode(method) {
    _classCallCheck(this, MethodNode);

    var _this = _possibleConstructorReturn(this, (MethodNode.__proto__ || Object.getPrototypeOf(MethodNode)).call(this));

    _this._method = method;
    return _this;
  }

  /**
   * @param {RoutingData} routingData
   * @returns {boolean}
   */


  _createClass(MethodNode, [{
    key: 'evaluate',
    value: function evaluate(routingData) {
      return routingData.incomingRequest.getMethod() == this._method;
    }

    /**
     * @param {ReverseRoutingData} reverseRoutingData
     */

  }, {
    key: 'reverseEvaluate',
    value: function reverseEvaluate(reverseRoutingData) {
      // No-op.
    }
  }, {
    key: 'isConsumingSegmentOnMatch',
    value: function isConsumingSegmentOnMatch() {
      return false;
    }

    /**
     * @param {Node} node
     * @returns {boolean}
     */

  }, {
    key: 'equals',
    value: function equals(node) {
      return node instanceof MethodNode && node._method == this._method;
    }
  }]);

  return MethodNode;
}(_Node3.default);

exports.default = MethodNode;
//# sourceMappingURL=MethodNode.js.map